package com.api.kq.browser.service.impl.jucailin;

import com.api.browser.bean.ListHeadBean;
import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SplitTableBean;
import com.api.browser.bean.SplitTableColBean;
import com.api.browser.service.BrowserService;
import com.api.browser.util.*;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 周期设置浏览按钮
 * type : cycleset
 */
public class KQCycleSetBrowserService extends BrowserService {

	@Override
	public Map<String, Object> getBrowserData(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();

		String cyclename = Util.null2String(params.get("cyclename"));

		String sqlWhere = Util.null2String(params.get("sqlWhere"));
		String sqlwhere = " where 1=1 and (delete_type is null or  delete_type <> '1') ";
		if(!cyclename.equals("")){
			sqlwhere += " and cyclename like '%";
			sqlwhere += Util.fromScreen2(cyclename,user.getLanguage());
			sqlwhere += "%'";
		}

		if(!sqlWhere.equals("")){
			sqlwhere += " and "+sqlWhere;
		}

		sqlwhere  = SqlUtils.replaceFirstAnd(sqlwhere);
		// 设置好搜索条件
		String backFields = " id ,cyclename ";
		String fromSql = " kq_cycle_setting ";

		List<SplitTableColBean> cols = new ArrayList<SplitTableColBean>();
		cols.add(new SplitTableColBean("true","id"));
		cols.add(new SplitTableColBean("100%",SystemEnv.getHtmlLabelName(388722, user.getLanguage()),"cyclename","cyclename").setIsInputCol(BoolAttr.TRUE).setShowType(1));

		SplitTableBean tableBean  =  new SplitTableBean(backFields,fromSql,sqlwhere,"id","id","asc",cols);
		apidatas.putAll(SplitTableUtil.makeListDataResult(tableBean));
		return apidatas;
	}

	@Override
	public Map<String, Object> getBrowserConditionInfo(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		List<SearchConditionItem> conditions = new ArrayList<SearchConditionItem>();
		apidatas.put(BrowserConstant.BROWSER_RESULT_CONDITIONS, conditions);

		ConditionFactory conditionFactory = new ConditionFactory(user);
		conditions.add(conditionFactory.createCondition(ConditionType.INPUT, 388722, "cyclename", true));

		return apidatas;
	}

	@Override
	public Map<String, Object> getMultBrowserDestData(Map<String, Object> params) throws Exception {
		Map<String, Object> apidatas = new HashMap<String, Object>();
		List<Map<String,Object>> datas  = new ArrayList<Map<String,Object>>();
		String selectids = Util.null2String(params.get(BrowserConstant.BROWSER_MULT_DEST_SELECTIDS));
		if(user==null||"".equals(selectids)){
			return apidatas;
		}
		RecordSet recordSet = new RecordSet();
		String tempSql = " select id,cyclename from kq_cycle_setting where 1=1 and (delete_type is null or  delete_type <> '1') and id in ("+selectids+") ";
		recordSet.executeQuery(tempSql);
		while (recordSet.next()){
			Map<String,Object> item = new HashMap<String,Object>();
			item.put("id", recordSet.getString("id"));
			item.put("cyclename", Util.null2String(recordSet.getString("cyclename")));
			datas.add(item);
		}
		List<ListHeadBean> tableHeadColumns =  new ArrayList<ListHeadBean>();
		tableHeadColumns.add(new ListHeadBean("id",BoolAttr.TRUE));
		tableHeadColumns.add(new ListHeadBean("cyclename","",1,BoolAttr.TRUE));

		apidatas.put(BrowserConstant.BROWSER_RESULT_COLUMN, tableHeadColumns);
		apidatas.put(BrowserConstant.BROWSER_RESULT_DATA, datas);
		apidatas.put(BrowserConstant.BROWSER_RESULT_TYPE, BrowserDataType.LIST_ALL_DATA.getTypeid());
		return apidatas;
	}

}
