package com.engine.jucailin.cmd.calendar;

import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.util.PageUidFactory;
import weaver.general.PageIdConst;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: sy
 * @Description: 日历设置列表
 * @Date: 2024/2/27
 **/
public class GetCalendarSettingListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCalendarSettingListCmd(Map<String, Object> params, User user){
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();

        String backFields = "a.id,a.calendar_name,a.default_calendar,a.calendar_desc";
        String sqlFrom = " kq_calendar_name a";
        String sqlWhere = " (a.delete_type is null or  a.delete_type <> '1') ";
        String orderby = " id ";
        String tableString = "";

        String pageId = PageUidFactory.getHrmPageUid("KQCalendarSettingList");
        WeaTable table = new WeaTable();
        table.setPageID(pageId);
        table.setPageUID(pageId + "_" + user.getUID());
        String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
        table.setPagesize(pageSize);

        table.setBackfields(backFields);
        table.setSqlform(sqlFrom);
        table.setSqlwhere(sqlWhere);
        table.setSqlprimarykey("id");
        table.setSqlorderby("id");
        table.getColumns().addAll(tableFields());

        //主要用于 显示定制列以及 表格 每页展示记录数选择
//        String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
//        Util_TableMap.setVal(sessionkey, tableString);
//        retmap.put("sessionkey", sessionkey);
//        retmap.put("status", "1");

        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        retmap.putAll(result.getResultMap());

        return retmap;
    }
    /**
     * 构建表格字段
     */
    private List<WeaTableColumn> tableFields() {
        return new ArrayList<WeaTableColumn>() {{
            add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(531231, user.getLanguage()), "calendar_name"));//日历名称
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(546298, user.getLanguage()), "default_calendar").setTransmethod("com.engine.jucailin.util.ListConversionMethod.getCheckValue").setOtherpara(user.getLanguage()+"").setColumn("default_calendar"));//默认日历
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(546299, user.getLanguage()), "calendar_desc"));//日历说明

        }};
    }

//
}
