package com.engine.jucailin.cmd.calendar.holidaySet;

import com.api.hrm.bean.TreeNode;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.util.DbTools;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: sy
 * @Description: 日历设置列表树
 * @Date: 2024/2/28
 **/
public class GetCalendarSettingTreeCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCalendarSettingTreeCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        TreeNode root = new TreeNode();
        String keyword = Util.null2String(params.get("keyword")).trim().toLowerCase();
        root.setId("0");
        root.setName("日历设置");
        root.setType("0");
        root.setIcon("icon-coms-LargeArea");
        List<TreeNode> groups = new ArrayList<TreeNode>();
        String sql = "select id,calendar_name from kq_calendar_name where 1=1";
        if (keyword.length() > 0){
            sql += " and calendar_name like '%" + keyword + "%' ";
        }
        List<Map<String,String>> dataList = DbTools.getSqlToList(sql);
        for (Map<String,String> data:dataList){
            TreeNode group = new TreeNode();
            group.setId(data.get("id"));
            group.setName(data.get("calendar_name"));
            group.setPid("0");
            group.setType("1");
            group.setCanClick(true);
            group.setIcon("icon-coms-LargeArea");
            groups.add(group);
        }
        root.setIsParent(groups.size()>0);
        root.setSubs(groups);
        Map<String, Object> treeObj = new HashMap<String, Object>();
        treeObj.put("rootCompany", root);
        return treeObj;
    }
}
