package com.engine.jucailin.cmd.common;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.util.DateUtil;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Map;

@Slf4j
public class DeleteDataCommonCmd extends AbstractCommonCommand<Map<String, Object>> {

    public DeleteDataCommonCmd(Map<String, Object> params, User user){
        this.params=params;
        this.user=user;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String,Object> resultMap = Maps.newHashMap();
        String tableNames = Util.null2String(params.get("tableName"));
        String billids = Util.null2String(params.get("billids"));
        String deleteType = Util.null2String(params.get("deleteType"));
        if ("".equals(deleteType)){
            deleteType = "delete_type";
        }
        String sql = "update "+tableNames +" set "+deleteType+"=1, update_time=? where id in ("+billids+")";
        log.info("DeleteDataCommonCmd sql : [{}]",sql);
        resultMap.put("result", DbTools.update(sql,DateUtil.getCurrentTime()));

        return resultMap;
    }
}
