package com.engine.jucailin.cmd.common;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.genid.IdGenerator;
import com.engine.jucailin.util.CommonUtil;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.List;
import java.util.Map;

public class InsertDataCommonCmd extends AbstractCommonCommand<Map<String, Object>> {

    public InsertDataCommonCmd(Map<String, Object> params, User user){
        this.params=params;
        this.user=user;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String tableName = Util.null2String(params.get("tableName"));
        Map<String,Object> dataMap = (Map<String,Object>)params.get("data");
        Map<String,Object> mainMap = Maps.newHashMap();
        Map<String,List<Map<String,Object>>> detailMap = Maps.newHashMap();
        for (Map.Entry<String, Object> entry: dataMap.entrySet()){
            String key = entry.getKey();
            if (key.startsWith("dt") && entry.getValue() instanceof List){
                detailMap.put(key,(List<Map<String,Object>>)entry.getValue());
            }else {
                mainMap.put(entry.getKey(),entry.getValue());
            }
        }
        long mainid = IdGenerator.generate();
        mainMap.put("id",mainid);
        Map<String,Object> resultMap = Maps.newHashMap();
        for (Map.Entry<String,List<Map<String,Object>>> detail: detailMap.entrySet()){
            String detailTableName = tableName+"_"+detail.getKey();
            List<Map<String,Object>> dataList = detail.getValue();
            if (dataList.size() > 0){
                List<Long> billids = Lists.newArrayList();
                for (Map<String,Object> data : dataList){
                    long detailId = IdGenerator.generate();
                    data.put("id",detailId);
                    data.put("mainid",mainid);
                    billids.add(detailId);
                    CommonUtil.fillSaveData(data,user);
                }
                if (!CommonUtil.insertBatch(dataList,detailTableName)){
                    resultMap.put(detailTableName,"fail");
                }
            }
        }
        if (!DbTools.update(CommonUtil.makeInsertSql(tableName,mainMap,user))){
            resultMap.put(tableName,"fail");
        }
        return resultMap;
    }
}
