package com.engine.jucailin.cmd.common;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Map;

public class QueryDataCommonCmd extends AbstractCommonCommand<Map<String, Object>> {

    public QueryDataCommonCmd(Map<String, Object> params, User user){
        this.params=params;
        this.user=user;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String tableNames = Util.null2String(params.get("tableNames"));
        String billid = Util.null2String(params.get("billid"));
        Map<String,Object> resultMap = Maps.newHashMap();
        for (String tableName :tableNames.split(",")){
            String sql = "select * from "+tableName+" where 1=1";
            if (tableName.contains("_dt")){
                sql += " and mainid="+billid;
            }else {
                sql += " and id="+billid;
            }
            resultMap.put(tableName, DbTools.getSqlToList(sql));
        }
        return resultMap;
    }
}
