package com.engine.jucailin.cmd.common;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.genid.IdGenerator;
import com.engine.jucailin.util.CommonUtil;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.List;
import java.util.Map;

public class UpdateDataCommonCmd extends AbstractCommonCommand<Map<String, Object>> {

    public UpdateDataCommonCmd(Map<String, Object> params, User user){
        this.params=params;
        this.user=user;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String tableName = Util.null2String(params.get("tableName"));
        Map<String,Object> dataMap = (Map<String,Object>)params.get("data");
        String billid = Util.null2String(params.get("billid"));
        Map<String, List<Map<String,Object>>> detailMap = Maps.newHashMap();
        Map<String,Object> mainMap = Maps.newHashMap();
        for (Map.Entry<String, Object> entry: dataMap.entrySet()){
            String key = entry.getKey();
            if (key.startsWith("dt") && entry.getValue() instanceof List){
                detailMap.put(key,(List<Map<String,Object>>)entry.getValue());
            }else {
                mainMap.put(entry.getKey(),entry.getValue());
            }
        }
        Map<String,Object> conditionMap = Maps.newHashMap();
        conditionMap.put("id",billid);
        Map<String,Object> resultMap = Maps.newHashMap();
        if (!DbTools.update(CommonUtil.makeUpdateSql(tableName,mainMap,conditionMap))){
            resultMap.put(tableName,"fail");
        }

        for (Map.Entry<String,List<Map<String,Object>>> detail: detailMap.entrySet()){
            String detailTableName = tableName+"_"+detail.getKey();
            List<Map<String,Object>> dataList = detail.getValue();
            List<String> resultList = Lists.newArrayList();
            for (Map<String,Object> data : dataList){
                String id = Util.null2String(data.get("dtid"));
                data.remove("dtid");
                conditionMap.put("mainid",billid);
                if (id.equals("")){
                    conditionMap.put("id", IdGenerator.generate());
                }else {
                    conditionMap.put("id",Long.valueOf(id));
                }
                if (!DbTools.update(CommonUtil.makeUpdateSql(detailTableName,data,conditionMap))){
                    resultList.add(conditionMap.get("id").toString());
                }
            }
            if (resultList.size() > 0){
                resultMap.put(detailTableName,resultList);
            }
        }
        return resultMap;
    }
}
