package com.engine.jucailin.cmd.cycle;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SearchConditionOption;
import com.api.hrm.bean.HrmFieldBean;
import com.api.hrm.util.HrmFieldSearchConditionComInfo;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.enums.FieldHtmlTypeEnum;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetCycleFormCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCycleFormCmd(Map<String, Object> params, User user){
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();
        List<Map<String, Object>> groupList = new ArrayList<Map<String, Object>>();
        Map<String, Object> groupItem = new HashMap<String, Object>();
        List<SearchConditionOption> optionsList = new ArrayList<SearchConditionOption>();
        List<Object> itemList = new ArrayList<Object>();

        HrmFieldSearchConditionComInfo hrmFieldSearchConditionComInfo = new HrmFieldSearchConditionComInfo();
        SearchConditionItem searchConditionItem = null;

        String billid = Util.null2String(params.get("billid"));
        boolean hasFieldvalue = false;
        Map<String,String> dateMap = Maps.newHashMap();
        if (billid.length() != 0) {
            dateMap = DbTools.getSqlToMap("select * from kq_cycle where id=?",billid);
            if (dateMap.size() > 0) {
                hasFieldvalue = true;
            }
        }

        HrmFieldBean hrmFieldBean = null;
        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("organzation");//所属机构
        hrmFieldBean.setFieldlabel("17868");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("164");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("organzation")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);


        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("cyclename");//周期名称
        hrmFieldBean.setFieldlabel("388722");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("cycleset");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("cyclename")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        List<Map<String, Object>> replaceDatas = new ArrayList<Map<String, Object>>();
        Map<String, Object> datas = new HashMap<String, Object>();
        if (hasFieldvalue && !Util.null2String(dateMap.get("cyclename")).equals("")){
            datas.put("id", dateMap.get("cyclename"));

            String sql = "select id,cyclename from kq_cycle_setting where (delete_type is null or  delete_type <> '1') and id=?";
            List<Map<String,String>> dataList = DbTools.getSqlToList(sql,dateMap.get("cyclename"));
            datas.put("name", dataList.get(0).get("cyclename"));
            replaceDatas.add(datas);
        }
        searchConditionItem.getBrowserConditionParam().setReplaceDatas(replaceDatas);

        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("attendcycle");//考勤周期
        hrmFieldBean.setFieldlabel("546323");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.INPUT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("attendcycle")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("yearly");//年度
        hrmFieldBean.setFieldlabel("17138");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.INPUT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("yearly")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("months");//月份
        hrmFieldBean.setFieldlabel("887");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.INPUT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("months")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("startdate");// 开始日期
        hrmFieldBean.setFieldlabel("740");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("2");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("startdate")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("enddate");// 结束日期
        hrmFieldBean.setFieldlabel("1323");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("2");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("enddate")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("cyclestate");// 状态
        hrmFieldBean.setFieldlabel("602");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.SELECT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("cyclestate")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        optionsList = new ArrayList<SearchConditionOption>();
        optionsList.add(new SearchConditionOption("0", "待关账", true));//待关账
        optionsList.add(new SearchConditionOption("1", "已关账"));//部门
        optionsList.add(new SearchConditionOption("2", "已结账"));//已结账
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("closedate");// 关账日期
        hrmFieldBean.setFieldlabel("546321");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("2");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("closedate")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("closetime");// 关账时间
        hrmFieldBean.setFieldlabel("546322");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("19");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("closetime")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("memo");// 备注
        hrmFieldBean.setFieldlabel("454");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.TEXTAREA.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("memo")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);


        groupItem.put("items", itemList);
        groupList.add(groupItem);
        retmap.put("condition", groupList);
        return retmap;
    }

}
