package com.engine.jucailin.cmd.cycle;

import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.pc.table.WeaTableOperate;
import com.cloudstore.eccom.pc.table.WeaTableOperates;
import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.util.PageUidFactory;
import weaver.general.PageIdConst;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetCycleListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCycleListCmd(Map<String, Object> params, User user){
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();

        String cyclename = Util.null2String(params.get("cyclename"));
        String year = Util.null2String(params.get("year"));

        String backFields = "a.id,a.cyclename,a.attendcycle,a.yearly,a.months,a.startdate,a.enddate,a.cyclestate,a.closedate,a.closetime,a.memo";
        String sqlFrom = " kq_cycle a";
        String sqlWhere = " (a.delete_type is null or  a.delete_type <> '1') ";
        String orderby = " id ";
        String tableString = "";

        if (cyclename.length() > 0) {
            sqlWhere += " and a.cyclename = "+cyclename ;
        }
        if (year.length() > 0){
            sqlWhere += "a.yearly = "+year;
        }

        String pageId = PageUidFactory.getHrmPageUid("KQCycleList");
        WeaTable table = new WeaTable();
        table.setPageID(pageId);
        table.setPageUID(pageId + "_" + user.getUID());
        String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
        table.setPagesize(pageSize);

        table.setBackfields(backFields);
        table.setSqlform(sqlFrom);
        table.setSqlwhere(sqlWhere);
        table.setSqlprimarykey("id");
        table.setSqlorderby("id");
        table.getColumns().addAll(tableFields());
        table.setOperates(getWeaTableOperates());

        //主要用于 显示定制列以及 表格 每页展示记录数选择
//        String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
//        Util_TableMap.setVal(sessionkey, tableString);
//        retmap.put("sessionkey", sessionkey);
//        retmap.put("status", "1");

        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        retmap.putAll(result.getResultMap());

        return retmap;
    }
    /**
     * 构建表格字段
     */
    private List<WeaTableColumn> tableFields() {
        return new ArrayList<WeaTableColumn>() {{
            add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(388722, user.getLanguage()), "cyclename","cyclename").setTransmethod("com.engine.jucailin.util.ListConversionMethod.getCycleName").setOtherpara(user.getLanguage()+"").setColumn("cyclename"));//周期名称
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(546323, user.getLanguage()), "attendcycle"));//考勤周期
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(17138, user.getLanguage()), "yearly"));//年度
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(887, user.getLanguage()), "months"));//月份
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(740, user.getLanguage()), "startdate"));//开始日期
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(1323, user.getLanguage()), "enddate"));//结束日期
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(602, user.getLanguage()), "cyclestate","cyclestate").setTransmethod("com.engine.jucailin.util.ListConversionMethod.getCyclestate").setOtherpara(user.getLanguage()+"").setColumn("cyclestate"));//状态
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(546321, user.getLanguage()), "closedate"));//关账日期
            add(new WeaTableColumn("10%",  SystemEnv.getHtmlLabelName(546322, user.getLanguage()), "closedate"));//关账时间
            add(new WeaTableColumn("10%", SystemEnv.getHtmlLabelName(454, user.getLanguage()), "memo"));//备注
        }};
    }

    /**
     * 设置表格右侧操作按钮
     */
    private WeaTableOperates getWeaTableOperates() {
        WeaTableOperates weaTableOperates = new WeaTableOperates();
        weaTableOperates.setOperate(new ArrayList<WeaTableOperate>() {{
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(91, user.getLanguage()), "javascript:doDel()", "1"));
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(513033, user.getLanguage()), "javascript:appendBill()", "2"));
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(546329, user.getLanguage()), "javascript:closeBill()", "3"));
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(546330, user.getLanguage()), "javascript:endBill()", "4"));
        }});
        return weaTableOperates;
    }
}
