package com.engine.jucailin.cmd.cycle;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SearchConditionOption;
import com.api.hrm.bean.HrmFieldBean;
import com.api.hrm.util.HrmFieldSearchConditionComInfo;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.enums.FieldHtmlTypeEnum;
import com.engine.jucailin.util.DbTools;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class GetCycleSearchConditionCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCycleSearchConditionCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> resultMap = new HashMap<String, Object>();

        List<Map<String, Object>> groupList = new ArrayList<Map<String, Object>>();
        Map<String, Object> groupItem = new HashMap<String, Object>();
        List<Object> itemList = new ArrayList<Object>();
        HrmFieldSearchConditionComInfo hrmFieldSearchConditionComInfo = new HrmFieldSearchConditionComInfo();
        SearchConditionItem searchConditionItem = null;
        HrmFieldBean hrmFieldBean = null;

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("yearly");//年度
        hrmFieldBean.setFieldlabel("17138");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.SELECT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        List<SearchConditionOption> optionsList = new ArrayList<SearchConditionOption>();
        String sql = "select yearly from kq_cycle where (delete_type is null or  delete_type <> '1') group by yearly";
        List<Map<String,String>> dataList = DbTools.getSqlToList(sql);
        if (dataList.size() > 0){
            optionsList.add(new SearchConditionOption(dataList.get(0).get("yearly"), dataList.get(0).get("yearly"),true));
            for (int i=1;i<dataList.size();i++){
                optionsList.add(new SearchConditionOption(dataList.get(i).get("yearly"), dataList.get(i).get("yearly")));
            }
        }
        searchConditionItem.setOptions(optionsList);
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("cyclename");//周期名称
        hrmFieldBean.setFieldlabel("388722");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.SELECT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        Map<String,String> cycleMap = getCycleNameMap();
        List<SearchConditionOption> cycleOptionsList = new ArrayList<SearchConditionOption>();
        sql = "select cyclename from kq_cycle  where (delete_type is null or  delete_type <> '1') group by cyclename";
        List<Map<String,String>> cyclenames = DbTools.getSqlToList(sql);
        if (cyclenames.size() > 0){
            cycleOptionsList.add(new SearchConditionOption(cyclenames.get(0).get("cyclename"), cycleMap.get(cyclenames.get(0).get("cyclename")),true));
            for (int i=1;i<cyclenames.size();i++){
                cycleOptionsList.add(new SearchConditionOption(cyclenames.get(i).get("cyclename"), cycleMap.get(cyclenames.get(i).get("cyclename"))));
            }
        }
        searchConditionItem.setOptions(cycleOptionsList);

        itemList.add(searchConditionItem);

        groupItem.put("items", itemList);
        groupList.add(groupItem);
        resultMap.put("condition", groupList);
        return resultMap;
    }

    public Map<String,String> getCycleNameMap(){
        String sql = "select id,cyclename from kq_cycle_setting where (delete_type is null or  delete_type <> '1') ";
        List<Map<String,String>> dataList = DbTools.getSqlToList(sql);
        Map<String,String> reusltMap = dataList.stream().collect(Collectors.toMap(e->e.get("id"),e->e.get("cyclename")));
        return reusltMap;
    }
}
