package com.engine.jucailin.cmd.cycle;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SearchConditionOption;
import com.api.hrm.bean.HrmFieldBean;
import com.api.hrm.util.HrmFieldSearchConditionComInfo;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.enums.FieldHtmlTypeEnum;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetCycleSettingFormCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCycleSettingFormCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();
        List<Map<String, Object>> groupList = new ArrayList<Map<String, Object>>();
        Map<String, Object> groupItem = new HashMap<String, Object>();
        List<SearchConditionOption> optionsList = new ArrayList<SearchConditionOption>();
        List<Object> itemList = new ArrayList<Object>();

        HrmFieldSearchConditionComInfo hrmFieldSearchConditionComInfo = new HrmFieldSearchConditionComInfo();
        SearchConditionItem searchConditionItem = null;

        String billid = Util.null2String(params.get("billid"));
        boolean hasFieldvalue = false;
        Map<String,String> dateMap = Maps.newHashMap();
        if (billid.length() != 0) {
            dateMap = DbTools.getSqlToMap("select * from kq_cycle_setting where id=?",billid);
            if (dateMap.size() > 0) {
                hasFieldvalue = true;
            }
        }

        HrmFieldBean hrmFieldBean = null;
        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("organzation");//所属机构
        hrmFieldBean.setFieldlabel("17868");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("164");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("organzation")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("attendance_organization");//适用对象
        hrmFieldBean.setFieldlabel("511548");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.TEXTAREA.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("attendance_organization")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        //searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("cyclename");//周期名称
        hrmFieldBean.setFieldlabel("388722");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.INPUT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("cyclename")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("ifdefault");//默认周期
        hrmFieldBean.setFieldlabel("149");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.CHECKBOX.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("ifdefault")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("memo");//说明
        hrmFieldBean.setFieldlabel("85");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.TEXTAREA.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("memo")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);


        groupItem.put("items", itemList);
        groupList.add(groupItem);
        retmap.put("condition", groupList);
        return retmap;
    }

}
