package com.engine.jucailin.cmd.cycle;

import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.pc.table.WeaTableOperate;
import com.cloudstore.eccom.pc.table.WeaTableOperates;
import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.util.PageUidFactory;
import weaver.general.PageIdConst;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetCycleSettingListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public  GetCycleSettingListCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();

        String cyclename = Util.null2String(params.get("cyclename"));

        String backFields = "a.id,a.ifdefault,a.cyclename,a.memo";
        String sqlFrom = " kq_cycle_setting a";
        String sqlWhere = " (a.delete_type is null or  a.delete_type <> '1') ";
        String orderby = " id ";
        String tableString = "";

        if (cyclename.length() > 0) {
            sqlWhere += " and a.cyclename =  like '%" + cyclename + "%' ";
        }

        String pageId = PageUidFactory.getHrmPageUid("KQCycleSettingList");
        WeaTable table = new WeaTable();
        table.setPageID(pageId);
        table.setPageUID(pageId + "_" + user.getUID());
        String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
        table.setPagesize(pageSize);

        table.setBackfields(backFields);
        table.setSqlform(sqlFrom);
        table.setSqlwhere(sqlWhere);
        table.setSqlprimarykey("id");
        table.setSqlorderby("id");
        table.getColumns().addAll(tableFields());
        table.setOperates(getWeaTableOperates());

        //主要用于 显示定制列以及 表格 每页展示记录数选择
//        String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
//        Util_TableMap.setVal(sessionkey, tableString);
//        retmap.put("sessionkey", sessionkey);
//        retmap.put("status", "1");

        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        retmap.putAll(result.getResultMap());

        return retmap;
    }
    /**
     * 构建表格字段
     */
    private List<WeaTableColumn> tableFields() {
        return new ArrayList<WeaTableColumn>() {{
            add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            add(new WeaTableColumn("20%", SystemEnv.getHtmlLabelName(195, user.getLanguage()), "cyclename"));//名称
            add(new WeaTableColumn("20%", SystemEnv.getHtmlLabelName(149, user.getLanguage()), "ifdefault"));//默认周期
            add(new WeaTableColumn("20%", SystemEnv.getHtmlLabelName(85, user.getLanguage()), "memo"));//说明
        }};
    }

    /**
     * 设置表格右侧操作按钮
     */
    private WeaTableOperates getWeaTableOperates() {
        WeaTableOperates weaTableOperates = new WeaTableOperates();
        weaTableOperates.setOperate(new ArrayList<WeaTableOperate>() {{
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(91, user.getLanguage()), "javascript:doDel()", "1"));
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(83, user.getLanguage()), "javascript:onLog()", "2"));
        }});
        return weaTableOperates;
    }
}
