package com.engine.jucailin.cmd.cycle;

import com.api.browser.bean.SearchConditionItem;
import com.api.browser.bean.SearchConditionOption;
import com.api.hrm.bean.HrmFieldBean;
import com.api.hrm.util.HrmFieldSearchConditionComInfo;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.enums.FieldHtmlTypeEnum;
import com.engine.jucailin.util.DbTools;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetCycledetailFormCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetCycledetailFormCmd(Map<String, Object> params, User user){
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();
        List<Map<String, Object>> groupList = new ArrayList<Map<String, Object>>();
        Map<String, Object> groupItem = new HashMap<String, Object>();
        List<SearchConditionOption> optionsList = new ArrayList<SearchConditionOption>();
        List<Object> itemList = new ArrayList<Object>();

        HrmFieldSearchConditionComInfo hrmFieldSearchConditionComInfo = new HrmFieldSearchConditionComInfo();
        SearchConditionItem searchConditionItem = null;

        String billid = Util.null2String(params.get("billid"));
        boolean hasFieldvalue = false;
        Map<String,String> dateMap = Maps.newHashMap();
        if (billid.length() != 0) {
            dateMap = DbTools.getSqlToMap("select * from kq_cycle_dt1 where id=?",billid);
            if (dateMap.size() > 0) {
                hasFieldvalue = true;
            }
        }

        HrmFieldBean hrmFieldBean = null;
        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("department");//特殊部门
        hrmFieldBean.setFieldlabel("546320");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("4");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("department")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("cyclestate");//状态
        hrmFieldBean.setFieldlabel("602");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.SELECT.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("cyclestate")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        optionsList.add(new SearchConditionOption("0","开账",true));
        optionsList.add(new SearchConditionOption("1","关账"));
        searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("close_date");//关账日期
        hrmFieldBean.setFieldlabel("546321");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("2");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("close_date")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("close_time");//关账时间
        hrmFieldBean.setFieldlabel("546322");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.BROWSER.getKey());
        hrmFieldBean.setType("19");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(3);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("close_time")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
        //searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("required|string");
        itemList.add(searchConditionItem);

        hrmFieldBean = new HrmFieldBean();
        hrmFieldBean.setFieldname("memo");//说明
        hrmFieldBean.setFieldlabel("85");
        hrmFieldBean.setFieldhtmltype(FieldHtmlTypeEnum.TEXTAREA.getKey());
        hrmFieldBean.setType("1");
        hrmFieldBean.setIsFormField(true);
        hrmFieldBean.setViewAttr(2);
        hrmFieldBean.setFieldvalue(hasFieldvalue ? Util.null2String(dateMap.get("memo")) : "");
        searchConditionItem = hrmFieldSearchConditionComInfo.getSearchConditionItem(hrmFieldBean, user);
       // searchConditionItem.setOptions(optionsList);
        searchConditionItem.setRules("");
        itemList.add(searchConditionItem);


        groupItem.put("items", itemList);
        groupList.add(groupItem);
        retmap.put("condition", groupList);
        return retmap;
    }

}
