package com.engine.jucailin.cmd.personGroup;

import com.cloudstore.eccom.constant.WeaBoolAttr;
import com.cloudstore.eccom.pc.table.WeaTable;
import com.cloudstore.eccom.pc.table.WeaTableColumn;
import com.cloudstore.eccom.pc.table.WeaTableOperate;
import com.cloudstore.eccom.pc.table.WeaTableOperates;
import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.util.PageUidFactory;
import weaver.general.PageIdConst;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetPersonGroupListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetPersonGroupListCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();

        String groupname = Util.null2String(params.get("groupname"));

        String subcompanyId = Util.null2String(params.get("subcompanyid"));

        String userfor = Util.null2String(params.get("userfor"));

        String backFields = "a.id,a.organzation,a.groupname,a.userfor,a.memo";
        String sqlFrom = " kq_persongroup a";
        String sqlWhere = " (delete_type is null or  delete_type <> '1') ";
        String orderby = " id ";
        String tableString = "";

        if (subcompanyId.length() > 0) {
            sqlWhere += " and organzation = " + subcompanyId;
        }
        if (groupname.length() > 0) {
            sqlWhere += " and groupname like '%" + groupname + "%' ";
        }
        if (userfor.length() > 0) {
            sqlWhere += " and userfor = " + userfor;
        }


        String pageId = PageUidFactory.getHrmPageUid("KQPersonGroupList");
        WeaTable table = new WeaTable();
        table.setPageID(pageId);
        table.setPageUID(pageId + "_" + user.getUID());
        String pageSize = PageIdConst.getPageSize(pageId, user.getUID());
        table.setPagesize(pageSize);

        table.setBackfields(backFields);
        table.setSqlform(sqlFrom);
        table.setSqlwhere(sqlWhere);
        table.setSqlprimarykey("id");
        table.setSqlorderby("id");
        table.getColumns().addAll(tableFields());
        table.setOperates(getWeaTableOperates());

        //主要用于 显示定制列以及 表格 每页展示记录数选择
//        String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
//        Util_TableMap.setVal(sessionkey, tableString);
//        retmap.put("sessionkey", sessionkey);
//        retmap.put("status", "1");

        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        retmap.putAll(result.getResultMap());

        return retmap;
    }
    /**ListConversionMethod
     * 构建表格字段
     */
    private List<WeaTableColumn> tableFields() {
        return new ArrayList<WeaTableColumn>() {{
            add(new WeaTableColumn("id").setDisplay(WeaBoolAttr.FALSE));
            add(new WeaTableColumn("20%", "所属机构", "organzation"));//所属机构
            add(new WeaTableColumn("20%", "分组名称", "groupname"));//分组名称
            add(new WeaTableColumn("20%", "应用场景", "userfor","userfor").setTransmethod("com.engine.jucailin.util.ListConversionMethod.getPersonGroupUserFor").setOtherpara(user.getLanguage()+"").setColumn("userfor"));//应用场景
            add(new WeaTableColumn("20%", "说明", "memo"));//说明
        }};
    }

    /**
     * 设置表格右侧操作按钮
     */
    private WeaTableOperates getWeaTableOperates() {
        WeaTableOperates weaTableOperates = new WeaTableOperates();
        weaTableOperates.setOperate(new ArrayList<WeaTableOperate>() {{
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(91, user.getLanguage()), "javascript:doDel()", "1"));
            add(new WeaTableOperate(SystemEnv.getHtmlLabelName(83, user.getLanguage()), "javascript:onLog()", "2"));
        }});
        return weaTableOperates;
    }
}
