package com.engine.jucailin.cmd.personGroup;

import com.cloudstore.dev.api.util.Util_TableMap;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.util.Constant;
import com.engine.kq.util.PageUidFactory;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.systeminfo.SystemEnv;
import weaver.systeminfo.systemright.CheckSubCompanyRight;

import java.util.HashMap;
import java.util.Map;

public class GetSuitOrganzationListCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetSuitOrganzationListCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();

        RecordSet rs = new RecordSet();
        try {
            if(!HrmUserVarify.checkUserRight("HrmKQGroup:Add",user)) {
                retmap.put("status", "-1");
                retmap.put("message", SystemEnv.getHtmlLabelName(2012, user.getLanguage()));
                return retmap;
            }
            //String groupId = Util.null2String(params.get("groupId"));
           // String subcompanyId = new KQGroupComInfo().getSubcompanyid(groupId);
            CheckSubCompanyRight checkSubCompanyRight = new CheckSubCompanyRight();
            ManageDetachComInfo manageDetachComInfo = new ManageDetachComInfo();
            boolean hrmdetachable = manageDetachComInfo.isUseHrmManageDetach();//是否开启了人力资源模块的管理分权
            //int operatelevel = -1;
            int operatelevel = 2;
//            if(hrmdetachable) {
//                operatelevel = checkSubCompanyRight.ChkComRightByUserRightCompanyId(user.getUID(), "HrmKQGroup:Add", Util.getIntValue(subcompanyId, -1));
//            }else{
//                operatelevel = 2;
//            }
//
//            if(user.getUID() == 1){
//                operatelevel = 2;
//            }

            String billid = Util.null2String(params.get("billid"));
            String tableName = Util.null2String(params.get("tableName"));
            String modeId = Constant.modeToTable.get(tableName);

            String hrmName = Util.null2String(params.get("hrmName"));
            String hrmJobtitle = Util.null2String(params.get("hrmJobtitle"));
            String hrmSubcompany = Util.null2String(params.get("hrmSubcompany"));
            String department = Util.null2String(params.get("department"));

            String validateFromDate = Util.null2String(params.get("validateFromDate"));
            String validateToDate = Util.null2String(params.get("validateToDate"));

            String backfields = " * ";
            String fromSql  = " kq_groupmember_"+modeId+" a ";
            String sqlWhere = " (delete_type is null "+(rs.getDBType().equals("oracle") ? "" : " or delete_type=0")+") ";
            String orderby = " a.id asc " ;

            if (billid.length() > 0){
                sqlWhere += " and dataid="+billid;
            }

            if(hrmName.length() > 0 ){
                sqlWhere += " and ( exists ( select 1 from hrmresource where a.typevalue=id and a.type=1 and lastname like '%"+hrmName+"%') " +
                        "	or exists ( select 1 from hrmjobtitles where a.typevalue=id and a.type=5 and jobtitlename like '%"+hrmName+"%')" +
                        " or exists ( select 1 from hrmsubcompany where a.typevalue=id and a.type=2 and subcompanyname like '%"+hrmName+"%')" +
                        " or exists ( select 1 from hrmdepartment where a.typevalue=id and a.type=3 and departmentname like '%"+hrmName+"%')) ";

            }
            if(hrmJobtitle.length() > 0){
                sqlWhere += " and a.membertype=5 and a.typevalue = "+hrmJobtitle;
            }
            if(hrmSubcompany.length() > 0){
                sqlWhere += " and a.membertype=2 and a.typevalue = "+hrmSubcompany;
            }
            if(department.length() >0){
                sqlWhere += " and a.membertype=3 and a.typevalue = "+department ;
            }

            if(validateFromDate.length() >0){
                if(rs.getDBType().equalsIgnoreCase("oracle")) {
                    sqlWhere += " and ('"+validateFromDate+"' between nvl(a.validatefrom,'2000-01-01') and nvl(a.validateto,'2999-12-31')) ";
                }else if((rs.getDBType()).equalsIgnoreCase("mysql")){
                    sqlWhere += " and ('"+validateFromDate+"' between ifnull(a.validatefrom,'2000-01-01') and ifnull(a.validateto,'2999-12-31')) ";
                }else {
                    sqlWhere += " and ('"+validateFromDate+"' between isnull(a.validatefrom,'2000-01-01') and isnull(a.validateto,'2999-12-31')) ";
                }
            }
            if(validateToDate.length() >0){
                if(rs.getDBType().equalsIgnoreCase("oracle")) {
                    sqlWhere += " and ('"+validateToDate+"' between nvl(a.validatefrom,'2000-01-01') and nvl(a.validateto,'2999-12-31')) ";
                }else if((rs.getDBType()).equalsIgnoreCase("mysql")){
                    sqlWhere += " and ('"+validateToDate+"' between ifnull(a.validatefrom,'2000-01-01') and ifnull(a.validateto,'2999-12-31')) ";
                }else {
                    sqlWhere += " and ('"+validateToDate+"' between isnull(a.validatefrom,'2000-01-01') and isnull(a.validateto,'2999-12-31')) ";
                }
            }

            String pageUid = PageUidFactory.getHrmPageUid("KQGroupMembersSearchList");

            String operateString= "<operates width=\"20%\">";
//            operateString+=" <popedom transmethod=\"com.engine.kq.util.TransMethod.getGroupMembersOperate\" otherpara=\""+groupId+"\"></popedom> ";
            //operateString+="     <operate href=\"javascript:doEdit();\" text=\""+SystemEnv.getHtmlLabelName(93,user.getLanguage())+"\" index=\"0\"/>";
            if(operatelevel > 1) {
                operateString += "     <operate href=\"javascript:doDel();\" text=\"" + SystemEnv.getHtmlLabelName(91, user.getLanguage()) + "\" index=\"0\"/>";
            }
            operateString+="     <operate href=\"javascript:doEdit();\" text=\""+SystemEnv.getHtmlLabelName(93,user.getLanguage())+"\" index=\"1\"/>";
            operateString+="</operates>";
            String tableString =" <table  pageUid=\""+pageUid+"\" pagesize=\"10\" tabletype=\"checkbox\">"+
                    " <sql backfields=\""+backfields+"\" sqlform=\""+fromSql+"\" sqlwhere=\""+Util.toHtmlForSplitPage(sqlWhere)+"\"  sqlorderby=\""+orderby+"\"  sqlprimarykey=\"a.id\" sqlsortway=\"desc\" sqlisdistinct=\"\"/>"+
//                    " <checkboxpopedom showmethod=\"com.engine.kq.util.TransMethod.getKQGroupMembersCheckbox\"  id=\"checkbox\"  popedompara=\"column:id+"+groupId+"\" />"+
                    operateString+
                    "	<head>"+
                    "	  <col width=\"0%\"  hide=\"true\"  text=\"\" column=\"id\"/>"+
                    "		<col width=\"25%\" text=\""+SystemEnv.getHtmlLabelName(21956,user.getLanguage())+"\" column=\"membertype\" orderkey=\"membertype\" transmethod=\"com.engine.hrm.util.HrmTransMethod.getResourceType\" otherpara=\""+user.getLanguage()+"\"/>"+
                    "		<col width=\"30%\" text=\""+SystemEnv.getHtmlLabelName(106,user.getLanguage())+"\" column=\"typevalue\" orderkey=\"typevalue\" transmethod=\"com.engine.hrm.util.HrmTransMethod.getResourceName\" otherpara=\"column:membertype+column:alllevel+"+user.getLanguage()+"+column:jobtitlelevel+column:jobtitlelevelvalue\" />"+
                    "		<col width=\"25%\" text=\""+SystemEnv.getHtmlLabelName(683,user.getLanguage())+"\" column=\"seclevel\" orderkey=\"seclevel\" transmethod=\"com.engine.hrm.util.HrmTransMethod.getSecLevel\" otherpara=\"column:seclevelto\"/>"+
                    "		<col width=\"25%\" text=\""+SystemEnv.getHtmlLabelName(19548,user.getLanguage())+"\" column=\"validatefrom\" orderkey=\"validatefrom\"/>"+
                    "		<col width=\"25%\" text=\""+SystemEnv.getHtmlLabelName(19547,user.getLanguage())+"\" column=\"validateto\" orderkey=\"validateto\"/>"+
                    "	</head>"+
                    " </table>";

            //主要用于 显示定制列以及 表格 每页展示记录数选择
            String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
            Util_TableMap.setVal(sessionkey, tableString);
            retmap.put("sessionkey", sessionkey);
            retmap.put("status", "1");
            if(operatelevel > 0){
                retmap.put("canAdd", true);
            }else{
                retmap.put("canAdd", false);
            }
            if(operatelevel > 1){
                retmap.put("canDel", true);
            }else{
                retmap.put("canDel", false);
            }
        } catch (Exception e) {
            retmap.put("status", "-1");
            retmap.put("message",  SystemEnv.getHtmlLabelName(382661,user.getLanguage()));
            writeLog(e);
        }

        return retmap;
    }

}
