package com.engine.jucailin.cmd.personGroup;

import com.alibaba.fastjson.JSON;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.biz.SimpleBizLogger;
import com.engine.common.constant.BizLogSmallType4Hrm;
import com.engine.common.constant.BizLogType;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailin.genid.IdGenerator;
import com.engine.jucailin.util.Constant;
import com.engine.kq.biz.KQGroupComInfo;
import com.engine.kq.biz.KQGroupMemberComInfo;
import com.engine.kq.log.KQLog;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.Reminder.KQAutoCardTask;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SaveSuitOrganzationCmd extends AbstractCommonCommand<Map<String, Object>> {
    private KQLog kqLog = new KQLog();
    private SimpleBizLogger logger;
    public SaveSuitOrganzationCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
//        String groupId = Util.null2String(params.get("groupId"));
//        this.boforeLog(groupId);
    }


    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> retmap = new HashMap<String, Object>();
        kqLog.info("params::::::::::::"+ JSON.toJSONString(params));
        RecordSet rs = new RecordSet();
        String sql = "";
        try {
            if (!HrmUserVarify.checkUserRight("HrmKQGroup:Add", user)) {
                retmap.put("status", "-1");
                retmap.put("message", SystemEnv.getHtmlLabelName(2012, user.getLanguage()));
                return retmap;
            }

            String tableName = Util.null2String(params.get("tableName"));
            String modeid = Constant.modeToTable.get(tableName);
            String billid = Util.null2String(params.get("billid"));
            String memberTableName = "kq_groupmember_"+modeid;
            String type = Util.null2String(params.get("type"));
            String resourceid = Util.null2String(params.get("resourceid"));
            String subcompanyid = Util.null2String(params.get("subcompanyid"));
            String departmentid = Util.null2String(params.get("departmentid"));
            String alllevel = Util.null2String(params.get("alllevel")).trim();
            String jobtitle = Util.null2String(params.get("jobtitle")).trim();
            String jobtitlelevel = Util.null2String(params.get("jobtitlelevel")).trim();
            String jobtitlesubcompany = Util.null2String(params.get("jobtitlesubcompany")).trim();
            String jobtitledepartment = Util.null2String(params.get("jobtitledepartment")).trim();

            String groupmemberId = Util.null2String(params.get("groupmemberId")).trim();
            String validateFromDate = Util.null2String(params.get("validateFromDate")).trim();
            String validateToDate = Util.null2String(params.get("validateToDate")).trim();

            String seclevel = Util.null2String(params.get("seclevel")).trim();
            String seclevelto = Util.null2String(params.get("seclevelto")).trim();

            if(!"".equals(groupmemberId)) {
                String searchSql = "select * from "+memberTableName+" where id="+groupmemberId;
                rs.executeQuery(searchSql);
                if(rs.next()) {
                    type = Util.null2String(rs.getString("membertype"));
                    if("1".equals(type)) {
                        resourceid = Util.null2String(rs.getString("typevalue"));
                    } else if("2".equals(type)) {
                        subcompanyid = Util.null2String(rs.getString("typevalue"));
                    } else if("3".equals(type)) {
                        departmentid = Util.null2String(rs.getString("typevalue"));
                    } else if("5".equals(type)) {
                        jobtitle = Util.null2String(rs.getString("typevalue"));
                    }
                    alllevel = Util.null2String(rs.getString("alllevel"));
                    jobtitlelevel = Util.null2String(rs.getString("jobtitlelevel"));
                    if("2".equals(jobtitlelevel)) {//岗位--分部
                        jobtitlesubcompany = Util.null2String(rs.getString("jobtitlelevelvalue"));
                    } else if("3".equals(jobtitlelevel)) {//岗位--部门
                        jobtitledepartment = Util.null2String(rs.getString("jobtitlelevelvalue"));
                    }
                    seclevel = Util.null2String(rs.getString("seclevel"));
                    seclevelto = Util.null2String(rs.getString("seclevelto"));
                }
            }
            kqLog.info("validateFromDate1111>>>>>>>>"+validateFromDate+"::::validateToDate::::"+validateToDate);
            if(!"".equals(validateFromDate) || !"".equals(validateToDate)) {
                // 1. 查找同级别的有效期
                sql = "select * from "+memberTableName+" where membertype=" + type + " and (delete_type is null or delete_type <> '1') and dataid="+billid+" " ;
                if(!"".equals(groupmemberId)) {
                    sql += "and id != "+groupmemberId;
                }
                if (rs.getDBType().equalsIgnoreCase("sqlserver")
                        || rs.getDBType().equalsIgnoreCase("mysql")) {
                    sql += " and (validatefrom is not null or validatefrom<>'')";
                    sql += " and (validateto is not null or validateto<>'')";
                } else {
                    sql += " and ((validatefrom is not null)";
                    sql += " or (validateto is not null))";
                }
                switch (Util.getIntValue(type)) {
                    case 1:
                        sql += " and typevalue in(" + resourceid + ")";
                        break;
                    case 2:
                        sql += " and typevalue in(" + subcompanyid + ") and (" + seclevel + " between seclevel and seclevelto or " + seclevelto + " between seclevel and seclevelto)";
                        break;
                    case 3:
                        sql += " and typevalue in(" + departmentid + ") and (" + seclevel + " between seclevel and seclevelto or " + seclevelto + " between seclevel and seclevelto)";
                        break;
                    case 5:
                        sql += " and typevalue in(" + jobtitle + ") and (" + seclevel + " between seclevel and seclevelto or "
                                + seclevelto + " between seclevel and seclevelto)";
                        if("2".equals(jobtitlelevel)) {
                            sql += " and (jobtitlelevelvalue in("+jobtitlesubcompany+") or jobtitlelevel=1)";
                        } else if("3".equals(jobtitlelevel)) {
                            sql += " and (jobtitlelevelvalue in("+jobtitledepartment+") or jobtitlelevel=1)";
                        }
                        break;
                    case 6:
                        sql += " and typevalue in(0)";
                        break;
                    default:
                        break;
                }
                rs.executeQuery(sql);
                new KQLog().info("sql>>>>>>>>>>>>>>>>"+sql);
                KQGroupComInfo kqGroupComInfo = new KQGroupComInfo();
                while (rs.next()) {
                    String groupid = Util.null2String(rs.getString("groupid"));
                    String validatefrom = Util.null2String(rs.getString("validatefrom"));
                    validatefrom = "".equals(validatefrom) ? "2000-01-01" : validatefrom;
                    String validateto = Util.null2String(rs.getString("validateto"));
                    validateto = "".equals(validateto) ? "2999-12-31" : validateto;
                    if (validateFromDate.compareTo(validatefrom)<=0 && validateToDate.compareTo(validatefrom)>=0
                            || validateFromDate.compareTo(validateto)<=0 && validateToDate.compareTo(validateto)>=0) {
                        retmap.put("status", "-1");
                        String kqGroupName = kqGroupComInfo.getGroupname(groupid);
                        retmap.put("message", "和'"+kqGroupName+"'考勤组的考勤组成员中有效期有交叉，不允许保存");
                        return retmap;
                    }
                }
            }
            kqLog.info("validateFromDate2222>>>>>>>>"+validateFromDate+"::::validateToDate::::"+validateToDate+":::groupmemberId::"+groupmemberId);
            if(!"".equals(groupmemberId)) {
                sql = " UPDATE "+memberTableName+" set validatefrom=? ,validateto=? where id=?";
                rs.executeUpdate(sql,(validateFromDate.length() == 0 ? "null" : validateFromDate),(validateToDate.length() == 0 ? "null" : validateToDate),groupmemberId);
            } else {
                String jobtitlelevelvalue = "";
                if (jobtitlelevel.equals("2")) {
                    jobtitlelevelvalue = jobtitlesubcompany;
                } else if (jobtitlelevel.equals("3")) {
                    jobtitlelevelvalue = jobtitledepartment;
                }


                String objId = "0";
                switch (Util.getIntValue(type)) {
                    case 1:
                        objId = resourceid;
                        break;
                    case 2:
                        objId = subcompanyid;
                        break;
                    case 3:
                        objId = departmentid;
                        break;
                    case 5:
                        objId = jobtitle;
                        break;
                    default:
                        break;
                }
                String[] arrObjIds = Util.splitString(objId, ",");
                new KQLog().info("arrObjIds>>>>>>>>>>>>>>>>" + objId);
                if("".equals(validateFromDate) && "".equals(validateToDate)) {
                    for (int i = 0; i < arrObjIds.length; i++) {
                        //考勤组成员重复判断,单条判断下
                        sql = " select count(id) from "+memberTableName+" where dataid=" + billid +
                                " and (delete_type is null or  delete_type <> '1') and typevalue = " + arrObjIds[i] + " and membertype = " + type;
                        if (alllevel.length() > 0) {
                            sql += " and alllevel = " + alllevel;
                        }
                        if (seclevel.length() > 0) {
                            sql += " and seclevel = " + seclevel;
                        }
                        if (seclevelto.length() > 0) {
                            sql += " and seclevelto = " + seclevelto;
                        }
                        if (jobtitlelevelvalue.length() > 0) {
                            sql += " and jobtitlelevelvalue = " + jobtitlelevelvalue;
                        }
                        if (jobtitlelevel.length() > 0) {
                            sql += " and jobtitlelevel = " + jobtitlelevel;
                        }
                        rs.executeQuery(sql);
                        new KQLog().info("sql2222>>>>>>>>>>>>>>>>" + sql);
                        if (rs.next() && rs.getInt(1) > 0) {
                            if (arrObjIds.length == 1) {
                                retmap.put("status", "-1");
                                retmap.put("message", SystemEnv.getHtmlLabelName(17567, user.getLanguage()));
                                return retmap;
                            } else {
                                continue;
                            }
                        }
                    }
                }

                //人员类型,后面的需要替换前面的数据
                //TODO 现在有有效期，一个人是可以存在多个考勤组内的
//				if(type.equals("1")){
//					sql = "update kq_groupmember set delete_type=1 where type=1 and typevalue= ? ";
//					rs.executeUpdate(sql,arrObjIds[i]);
//				}
                for (int i = 0; i < arrObjIds.length; i++) {
                    sql = " INSERT INTO "+memberTableName+" (id, dataid ,typevalue ,membertype ,alllevel ," +
                            " seclevel ,seclevelto ,jobtitlelevelvalue ,jobtitlelevel,validatefrom,validateto) " +
                            " VALUES  ( "+ IdGenerator.generate()+", " + billid + ", " + arrObjIds[i] + " , '" + type + "', " +
                            " " + (alllevel.length() == 0 ? "null" : alllevel) + "," + (seclevel.length() == 0 ? "null" : seclevel) + "," +
                            " " + (seclevelto.length() == 0 ? "null" : seclevelto) + ", " + (jobtitlelevelvalue.length() == 0 ? "null" : jobtitlelevelvalue) + ","
                            + (jobtitlelevel.length() == 0 ? "null" : jobtitlelevel) + "," + (validateFromDate.length() == 0 ? "null" : "'" + validateFromDate + "'") + ","
                            + (validateToDate.length() == 0 ? "null" : "'" + validateToDate + "'") + ")";
                    rs.executeUpdate(sql);
                }
            }

            new KQGroupMemberComInfo().removeCache();
            //格式化考勤
//			new KQFormatBiz().formatDateByGroupId(groupId, DateUtil.getCurrentDate());

            KQGroupComInfo kQGroupComInfo = new KQGroupComInfo();
            String auto_checkout = kQGroupComInfo.getAuto_checkout(billid);
            String auto_checkin = kQGroupComInfo.getAuto_checkin(billid);
            if("1".equalsIgnoreCase(auto_checkin) || "1".equalsIgnoreCase(auto_checkout)){
                //如果开启了自动打卡，保存考勤组成员之后需要格式化下缓存
                KQAutoCardTask kqAutoCardTask = new KQAutoCardTask();
                kqAutoCardTask.initAutoCardTask(billid);
            }
            retmap.put("status", "1");
        } catch (Exception e) {
            retmap.put("status", "-1");
            retmap.put("message", SystemEnv.getHtmlLabelName(382661, user.getLanguage()));
            writeLog(e);
        }
        return retmap;
    }

    private void boforeLog(String id){
        this.logger = new SimpleBizLogger();
        BizLogContext logContext = new BizLogContext();
        logContext.setDateObject(new Date());
        logContext.setLogType(BizLogType.HRM_ENGINE);
        logContext.setBelongType(BizLogSmallType4Hrm.HRM_ENGINE_KQGROUP);
        logContext.setLogSmallType(BizLogSmallType4Hrm.HRM_ENGINE_KQGROUP);
        logContext.setParams(params);
        logger.setUser(user);//当前操作人

        String mainSql = " select * from kq_group where id= " + id;
        logger.setMainSql(mainSql);//主表sql
        logger.setMainPrimarykey("id");//主日志表唯一key
        logger.setMainTargetNameColumn("groupname");

        SimpleBizLogger.SubLogInfo subLogInfo1 = logger.getNewSubLogInfo();
        String subSql1 = "select * from kq_groupmember where (delete_type is null or delete_type <> '1') and groupid="+id;
        subLogInfo1.setSubPrimarykey("id");
        subLogInfo1.setSubTargetNameColumn("id");
        subLogInfo1.setGroupId("0");  //所属分组， 按照groupid排序显示在详情中， 不设置默认按照add的顺序。
        subLogInfo1.setSubGroupNameLabel(388736); //在详情中显示的分组名称，不设置默认显示明细x
        subLogInfo1.setSubSql(subSql1);
        logger.addSubLogInfo(subLogInfo1);

        logger.before(logContext);
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public List<BizLogContext> getLogContexts() {
        return logger.getBizLogContexts();
    }
}
