package com.engine.jucailin.service.impl;

import com.engine.core.impl.Service;
import com.engine.jucailin.cmd.common.DeleteDataCommonCmd;
import com.engine.jucailin.cmd.common.InsertDataCommonCmd;
import com.engine.jucailin.cmd.common.QueryDataCommonCmd;
import com.engine.jucailin.cmd.common.UpdateDataCommonCmd;
import com.engine.jucailin.service.KQCommonService;
import com.google.common.collect.Maps;
import com.google.gson.Gson;
import weaver.general.Util;

import java.lang.reflect.Type;
import java.util.Map;

public class KQCommonServiceImpl extends Service implements KQCommonService {
    @Override
    public Map<String,Object> saveKQData(Map<String,Object> param) {
        //1：新增，2：更新
        String type = Util.null2String(param.get("type"));
        String data = Util.null2String(param.get("data"));
        Gson gson = new Gson();
        Map<String,Object> dataMap = gson.fromJson(data, (Type) Map.class);
        param.put("data",dataMap);
        Map<String,Object> resultMap = Maps.newHashMap();
        if ("1".equals(type)){
            resultMap = commandExecutor.execute(new InsertDataCommonCmd(param, user));
        }else if ("2".equals(type)){
            resultMap = commandExecutor.execute(new UpdateDataCommonCmd(param, user));
        }
        if (resultMap.size() > 0){
            resultMap.put("message","保存失败");
        }else {
            resultMap.put("message","保存成功");
        }
        return resultMap;
    }

    @Override
    public Map<String, Object> doQueryCommon(Map<String, Object> param) {
        return commandExecutor.execute(new QueryDataCommonCmd(param, user));
    }

    @Override
    public Map<String, Object> delCommon(Map<String, Object> param) {
        return commandExecutor.execute(new DeleteDataCommonCmd(param, user));
    }
}
