package com.engine.jucailin.service.impl;

import com.engine.core.impl.Service;
import com.engine.jucailin.cmd.common.DeleteDataCommonCmd;
import com.engine.jucailin.cmd.personGroup.GetPersonGroupListCmd;
import com.engine.jucailin.cmd.personGroup.GetSuitOrganzationFormCmd;
import com.engine.jucailin.cmd.personGroup.GetSuitOrganzationListCmd;
import com.engine.jucailin.cmd.personGroup.SaveSuitOrganzationCmd;
import com.engine.jucailin.service.KQPersonGroupService;
import com.engine.jucailin.util.Constant;
import weaver.general.Util;

import java.util.Map;

public class KQPersonGroupServiceImpl extends Service implements KQPersonGroupService {
    @Override
    public Map<String, Object> getPersonGroupList(Map<String, Object> params) {
        return commandExecutor.execute(new GetPersonGroupListCmd(params,user));
    }

    @Override
    public Map<String, Object> getSuitOrganzationList(Map<String, Object> params) {
        return commandExecutor.execute(new GetSuitOrganzationListCmd(params,user));
    }

    @Override
    public Map<String, Object> getSuitOrganzationForm(Map<String, Object> params) {
        return commandExecutor.execute(new GetSuitOrganzationFormCmd(params,user));
    }

    @Override
    public Map<String, Object> saveSuitOrganzation(Map<String, Object> params) {
        return commandExecutor.execute(new SaveSuitOrganzationCmd(params,user));
    }

    @Override
    public Map<String, Object> delSuitOrganzation(Map<String, Object> params) {
        String tableName = Util.null2String(params.get("tableName"));
        String modeid = Constant.modeToTable.get(tableName);
        String memberTableName = "kq_groupmember_"+modeid;
        params.put("tableName",memberTableName);
        return commandExecutor.execute(new DeleteDataCommonCmd(params,user));
    }
}
