package com.engine.jucailin.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.jucailin.service.KQCalendarSettingService;
import com.engine.jucailin.service.impl.KQCalendarSettingServiceImpl;
import com.engine.jucailin.util.ResponseResult;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @Author: sy
 * @Description: 日历设置
 * @Date: 2024/2/27
 **/
public class KQCalendarSettingAction {

    private KQCalendarSettingService getKQCalendarSettingService(User user) {
        return ServiceUtil.getService(KQCalendarSettingServiceImpl.class,user);
    }

    /**
     * 日历设置列表
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCalendarSettingList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCalendarSettingList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCalendarSettingService(user) :: getCalendarSettingList,param);
    }

    /**
     * 日历设置表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCalendarSettingForm")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCalendarSettingForm(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCalendarSettingService(user) :: getCalendarSettingForm,param);
    }

    /**
     * 周期设置树
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCalendarSettingTree")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCalendarSettingTree(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCalendarSettingService(user) :: getCalendarSettingTree,param);
    }
}
