package com.engine.jucailin.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.jucailin.service.KQCommonService;
import com.engine.jucailin.service.impl.KQCommonServiceImpl;
import com.engine.jucailin.util.ResponseResult;
import lombok.extern.slf4j.Slf4j;
import oracle.jdbc.proxy.annotation.Post;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

@Slf4j
public class KQCommonAction {

    private KQCommonService getKQCommonService(User user) {
        return ServiceUtil.getService(KQCommonServiceImpl.class,user);
    }

    /**
     * 更新考勤数据
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/doSubmit")
    @Produces(MediaType.APPLICATION_JSON)
    public String saveKQData(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: saveKQData,param);
    }

    /**
     * 查询详情页面
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/doQueryCommon")
    @Produces(MediaType.APPLICATION_JSON)
    public String doQueryCommon(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: doQueryCommon,param);
    }

    /**
     * 删除考勤数据
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/delCommon")
    @Produces(MediaType.APPLICATION_JSON)
    public String delCommon(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: delCommon,param);
    }



}
