package com.engine.jucailin.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ResponseResult;
import com.engine.common.util.ServiceUtil;
import com.engine.jucailin.service.KQCycleSettingService;
import com.engine.jucailin.service.impl.KQCycleSettingServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class KQCycleSettingAction {

    private KQCycleSettingService getKQCycleSettingService(User user) {
        return ServiceUtil.getService(KQCycleSettingServiceImpl.class,user);
    }

    /**
     * 周期设置列表
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleSettingList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleSettingList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleSettingList,param);
    }

    /**
     * 周期设置树
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleSettingTree")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleSettingTree(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleSettingTree,param);
    }
    /**
     * 周期设置表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleSettingForm")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleSettingForm(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleSettingForm,param);
    }

    /**
     * 考勤周期列表查询
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleList,param);
    }
    /**
     * 考勤周期表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleForm")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleForm(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleForm,param);
    }

    /**
     * 考勤周期高级搜索表单表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycleSearchCondition")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycleSearchCondition(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycleSearchCondition,param);
    }

    /**
     * 考勤周期明细表1列表查询
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycledetailList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycledetailList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycledetailList,param);
    }
    /**
     * 考勤周期明细表1新建表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getCycledetailForm")
    @Produces(MediaType.APPLICATION_JSON)
    public String getCycledetailForm(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: getCycledetailForm,param);
    }

    /**
     * 考勤周期关账
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/closeBill")
    @Produces(MediaType.APPLICATION_JSON)
    public String closeBill(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: closeBill,param);
    }

    /**
     * 考勤周期结账
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/endBill")
    @Produces(MediaType.APPLICATION_JSON)
    public String endBill(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCycleSettingService(user) :: endBill,param);
    }

}
