package com.engine.jucailin.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.jucailin.service.KQPersonGroupService;
import com.engine.jucailin.service.impl.KQPersonGroupServiceImpl;
import com.engine.jucailin.util.ResponseResult;
import lombok.extern.slf4j.Slf4j;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

@Slf4j
public class KQPersonGroupAction {

    private KQPersonGroupService getKQCommonService(User user) {
        return ServiceUtil.getService(KQPersonGroupServiceImpl.class,user);
    }

    /**
     * 人员分组列表查询
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getPersonGroupList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getPersonGroupList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: getPersonGroupList,param);
    }

    /**
     * 适用组织列表查询
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getSuitOrganzationList")
    @Produces(MediaType.APPLICATION_JSON)
    public String getSuitOrganzationList(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: getSuitOrganzationList,param);
    }

    /**
     * 适用组织表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getSuitOrganzationForm")
    @Produces(MediaType.APPLICATION_JSON)
    public String getSuitOrganzationForm(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: getSuitOrganzationForm,param);
    }
    /**
     * 适用组织表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/saveSuitOrganzation")
    @Produces(MediaType.APPLICATION_JSON)
    public String saveSuitOrganzation(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: saveSuitOrganzation,param);
    }
    /**
     * 适用组织表单
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/delSuitOrganzation")
    @Produces(MediaType.APPLICATION_JSON)
    public String delSuitOrganzation(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String,Object> param = ParamUtil.request2Map(request);
        return new ResponseResult<Map<String, Object>, Map<String, Object>>(user).run(getKQCommonService(user) :: delSuitOrganzation,param);
    }


}
